/*
 * Copyright 2010 JBoss Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.drools.guvnor.client.util;

import com.google.gwt.event.dom.client.KeyPressEvent;
import com.google.gwt.event.dom.client.KeyPressHandler;
import com.google.gwt.user.client.ui.TextBox;

public class NumbericFilterKeyPressHandler
    implements
    KeyPressHandler {

    private final TextBox box;

    public NumbericFilterKeyPressHandler(TextBox box) {
        this.box = box;
    }

    public void onKeyPress(KeyPressEvent event) {
        char c = event.getCharCode();
        TextBox w = (TextBox) event.getSource();
        if ( Character.isLetter( c ) && c != '=' && !(box.getText().startsWith( "=" )) ) {
            ((TextBox) w).cancelKey();
        }
    }

}
